
import java.util.StringTokenizer;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Arrays;

/**
 *
 * @author cteam049
 */
public class rhino
{

    protected Player[] players;
    
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args)
    {
        rhino program = new rhino();
        program.run();
    }

    
    
    protected void run()
    {
        try
        {
            for( ;; )
            {
                int  playersCnt = this.nextInt();
                this.players = new Player[ playersCnt ];
                
                int[] tmpCards = new int[5];
                int[] tmpColors = new int[5];
                
                String tmp;
                
                for ( int i = 0; i < 5; i++ )
                {
                    tmp = this.nextToken();
                    tmpCards[ i ] = cardToInt( tmp.charAt( 0 ) );
                    tmpColors[ i ] = colorToInt( tmp.charAt( 1 ) );
                }
                
                int tmpCard;
                int tmpColor;
                
                for ( int i = 0; i < playersCnt; i++ )
                {
                    this.players[ i ].addCards( tmpCards, tmpColors );
                    
                    for ( int j = 0; j < 2; j++ )
                    {
                        tmp = this.nextToken();
                        tmpCard = cardToInt( tmp.charAt( 0 ) );
                        tmpColor = colorToInt( tmp.charAt( 1 ) );
                        
                        this.players[ i ].cards[ 5 + j ] = tmpCard;
                        this.players[ i ].colors[ 5 + j ] = tmpColor;
                    }
                    
                    this.players[ i ].sortArrays();
                    this.players[ i ].findValue();
                }
                
                
            }
        }
        catch ( Exception e )
        {
            e.printStackTrace();
        }
    }
    
    
    
    protected int cardToInt( char card )
    {
        if ( card <= '9' && card >= '2' )
        {
            return Integer.valueOf( card );
        }
        
        switch ( card )
        {
            case 'X': return 10;
            case 'J': return 11;
            case 'Q': return 12;
            case 'K': return 13;
            case 'A': return 14;
        }
        
        return 0;
    }
    
    
    
    protected int colorToInt( char color )
    {
        switch ( color )
        {
            case 'c': return 1;
            case 'd': return 2;
            case 'h': return 3;
            case 's': return 4;
        }
        
        return 0;
    }
    
    
    
    
    
    
    
    protected class Player
    {
        public int[] colors = new int[7];
        public int[] cards  = new int[7];
        public int   value;
        
        public void addCards( int[] cards, int [] colors )
        {
            for ( int i = 0; i < 5; i++ )
            {
                this.cards[i] = cards[i];
                this.colors[i] = colors[i];
            }
        }
        
        public void sortArrays()
        {
            Arrays.sort( this.colors );
            Arrays.sort( this.cards );
        }
        
        public void findValue()
        {
            
        }
    }
    
    
    
    protected boolean flush( Player pl )
    {
        for ( int i = 0; i < 3; i++ )
        {
            if ( pl.colors[ i ] == pl.colors[ i + 4 ] )
                return true;
        }
        
        return false;
    }
    
    
    
    protected boolean straight(  Player pl  )
    {
        for ( int i = 0; i < 2; i++ )
        {
            
        }
        return false;
    }
    
    
    
    protected boolean three( Player pl )
    {
        for ( int i = 0; i < 5; i++ )
        {
            if ( pl.cards[ i ] == pl.cards[ i + 2 ] )
                return true;
        }
        
        return false;
    }
    
    
    
    protected boolean pair( Player pl )
    {
        for ( int i = 0; i < 6; i++ )
        {
            if ( pl.cards[ i ] == pl.cards[ i + 1 ] )
                return true;
        }
        
        return false;
    }
    
    
    
    
    
    
    
    /* INPUT READING */
    StringTokenizer st = new StringTokenizer("");
    BufferedReader input = new BufferedReader(new InputStreamReader(System.in));

    public String nextToken() throws Exception {
        while (!st.hasMoreTokens()) {
            st = new StringTokenizer(input.readLine());
        }
        return st.nextToken();
    }

    public int nextInt() throws Exception {
        return Integer.parseInt(this.nextToken());
    }

    public String nextLine() throws Exception {
        return input.readLine();
    }
    
}
